/*
	$Id: Constant.java 267 2006-08-19 16:33:30Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   󷿤Ǥ

   constantǤбޤ
*/
public class Constant {

    /** ̾ */
    private String name;

    /**  */
    private String value;

    /** descǤ */
    private Description desc;

    /**
       󷿤ޤ

       @param gm 롼ץޥ͡
       @param elem constant
    */
    public Constant(final GroupManager gm, final Element elem) {
	name = gm.expandNS(elem, "name");
	value = elem.getAttribute("value");
	if (elem.getAttributeNode("value") != null && value.equals("")) {
	    String m = "empty value";
	    throw new NodeException(elem.getAttributeNode("value"), m);
	}

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ̾ޤ

       @return ̾
    */
    public String getName() {
	return name;
    }

    /**
       󷿤ΥФɽʸޤ

       ͤꤵƤʤ硢֤̾ޤǤ
        "̾ = " ֤ޤ

       @return 󷿤Υ
    */
    public String getCode() {
	if (value.equals("")) {
	    return name;
	}
	return name + " = " + value;
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + name + "\"><b>" + name + "</b></a>"
+ "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<dl><a name=\"" + name + "\"></a>" + name + "<dd>\n"
+ desc.getText() + "</dd></dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	wr.println(""
+ "\\item[{\\ttfamily " + Tex.safe(name) + "}]\n"
+ desc.getTexText());
    }
}
