/*
	$Id: Interface.java 253 2006-08-13 14:05:36Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   󥿥եǤ
*/
public class Interface extends Group {

    /** ᥽åɤΥå */
    private Methods methods;

    /**
       󥿥եޤ

       @param elem interface
    */
    public Interface(final Element elem) {
	super(elem);

	ChildrenFilter c = getChildrenFilter();
	GroupManager gm = getGroupManager();
	methods = new RegularMethods(
	    gm, c.getDirectChildrenByTagName("method"));
    }

    /**
       {@inheritDoc}
    */
    @Override public void printCode() {
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getType() {
	return "interface";
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printHtml(final PrintWriter wr) {
	methods.printSummary(wr);
	methods.printDetail(wr);
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printTex(final PrintWriter wr) {
	methods.printTexDetail(wr);
    }

    /**
       {@inheritDoc}
    */
    @Override public void printStub() {
    }
}
